Index: dll/shellext/shellbtrfs/devices.h
===================================================================
--- dll/shellext/shellbtrfs/devices.h	(nonexistent)
+++ dll/shellext/shellbtrfs/devices.h	(copie de travail)
@@ -0,0 +1,167 @@
+/* Copyright (c) Mark Harmstone 2016-17
+ *
+ * This file is part of WinBtrfs.
+ *
+ * WinBtrfs is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public Licence as published by
+ * the Free Software Foundation, either version 3 of the Licence, or
+ * (at your option) any later version.
+ *
+ * WinBtrfs is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public Licence for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public Licence
+ * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
+
+#ifndef __REACTOS__
+#include <windows.h>
+#include <winternl.h>
+#else
+#define WIN32_NO_STATUS
+#include <windef.h>
+#include <winbase.h>
+#include <ndk/iofuncs.h>
+#include <ndk/iotypes.h>
+#endif
+#include <shlobj.h>
+#include <vector>
+#include <string>
+#ifndef __REACTOS__
+#include "../btrfsioctl.h"
+#else
+#include "btrfsioctl.h"
+#endif
+
+typedef struct {
+    std::wstring pnp_name;
+    std::wstring friendly_name;
+    std::wstring drive;
+    std::wstring fstype;
+    ULONG disk_num;
+    ULONG part_num;
+    UINT64 size;
+    BOOL has_parts;
+    BTRFS_UUID fs_uuid;
+    BTRFS_UUID dev_uuid;
+    BOOL ignore;
+    BOOL multi_device;
+    BOOL is_disk;
+} device;
+
+typedef struct {
+    const WCHAR* name;
+    const char* magic;
+    ULONG magiclen;
+    UINT32 sboff;
+    UINT32 kboff;
+} fs_identifier;
+
+// This list is compiled from information in libblkid, part of util-linux
+// and likewise under the LGPL. Thanks!
+
+const static fs_identifier fs_ident[] = {
+    { L"BeFS", "BFS1", 4, 0x20, 0 },
+    { L"BeFS", "1SFB", 4, 0x20, 0 },
+    { L"BeFS", "BFS1", 4, 0x220, 0 },
+    { L"BeFS", "1SFB", 4, 0x220, 0 },
+    { L"BFS", "\xce\xfa\xad\x1b", 4, 0, 0 },
+    { L"RomFS", "-rom1fs-", 8, 0, 0 },
+    { L"SquashFS", "hsqs", 4, 0, 0 },
+    { L"SquashFS", "sqsh", 4, 0, 0 },
+    { L"SquashFS", "hsqs", 4, 0, 0 },
+    { L"UBIFS", "\x31\x18\x10\x06", 4, 0, 0 },
+    { L"XFS", "XFSB", 4, 0, 0 },
+    { L"ext2", "\123\357", 2, 0x38, 1 },
+    { L"F2FS", "\x10\x20\xF5\xF2", 4, 0, 1 },
+    { L"HFS", "BD", 2, 0, 1 },
+    { L"HFS", "BD", 2, 0, 1 },
+    { L"HFS", "H+", 2, 0, 1 },
+    { L"HFS", "HX", 2, 0, 1 },
+    { L"Minix", "\177\023", 2, 0x10, 1 },
+    { L"Minix", "\217\023", 2, 0x10, 1 },
+    { L"Minix", "\023\177", 2, 0x10, 1 },
+    { L"Minix", "\023\217", 2, 0x10, 1 },
+    { L"Minix", "\150\044", 2, 0x10, 1 },
+    { L"Minix", "\170\044", 2, 0x10, 1 },
+    { L"Minix", "\044\150", 2, 0x10, 1 },
+    { L"Minix", "\044\170", 2, 0x10, 1 },
+    { L"Minix", "\132\115", 2, 0x10, 1 },
+    { L"Minix", "\115\132", 2, 0x10, 1 },
+    { L"OCFS", "OCFSV2", 6, 0, 1 },
+    { L"SysV", "\x2b\x55\x44", 3, 0x400, 1 },
+    { L"SysV", "\x44\x55\x2b", 3, 0x400, 1 },
+    { L"VXFS", "\365\374\001\245", 4, 0, 1 },
+    { L"OCFS", "OCFSV2", 6, 0, 2 },
+    { L"ExFAT", "EXFAT   ", 8, 3 },
+    { L"NTFS", "NTFS    ", 8, 3 },
+    { L"NetWare", "SPB5", 4, 0, 4 },
+    { L"OCFS", "OCFSV2", 6, 0, 4 },
+    { L"HPFS", "\x49\xe8\x95\xf9", 4, 0, 8 },
+    { L"OCFS", "OracleCFS", 9, 0, 8 },
+    { L"OCFS", "OCFSV2", 6, 0, 8 },
+    { L"ReFS", "\000\000\000ReFS\000", 8 },
+    { L"ReiserFS", "ReIsErFs",  8, 0x34, 8 },
+    { L"ReiserFS", "ReIsErFs",  8, 20,  8 },
+    { L"ISO9660", "CD001", 5, 1, 32, },
+    { L"ISO9660", "CDROM", 5, 9, 32, },
+    { L"JFS", "JFS1", 4, 0, 32 },
+    { L"OCFS", "ORCLDISK", 8, 32 },
+    { L"UDF", "BEA01", 5, 1, 32 },
+    { L"UDF", "BOOT2", 5, 1, 32 },
+    { L"UDF", "CD001", 5, 1, 32 },
+    { L"UDF", "CDW02", 5, 1, 32 },
+    { L"UDF", "NSR02", 5, 1, 32 },
+    { L"UDF", "NSR03", 5, 1, 32 },
+    { L"UDF", "TEA01", 5, 1, 32 },
+    { L"Btrfs", "_BHRfS_M", 8, 0x40, 64 },
+    { L"GFS", "\x01\x16\x19\x70", 4, 0, 64 },
+    { L"GFS", "\x01\x16\x19\x70", 4, 0, 64 },
+    { L"ReiserFS", "ReIsEr2Fs", 9, 0x34, 64 },
+    { L"ReiserFS", "ReIsEr3Fs", 9, 0x34, 64 },
+    { L"ReiserFS", "ReIsErFs",  8, 0x34, 64 },
+    { L"ReiserFS", "ReIsEr4", 7, 0, 64 },
+    { L"VMFS", "\x0d\xd0\x01\xc0", 4, 0, 1024 },
+    { L"VMFS", "\x5e\xf1\xab\x2f", 4, 0, 2048 },
+    { L"FAT", "MSWIN",    5, 0x52, 0 },
+    { L"FAT", "FAT32   ", 8, 0x52, 0 },
+    { L"FAT", "MSDOS",    5, 0x36, 0 },
+    { L"FAT", "FAT16   ", 8, 0x36, 0 },
+    { L"FAT", "FAT12   ", 8, 0x36, 0 },
+    { L"FAT", "FAT     ", 8, 0x36, 0 },
+    { L"FAT", "\353",     1, 0, 0 },
+    { L"FAT", "\351",     1, 0, 0},
+    { L"FAT", "\125\252", 2, 0x1fe, 0 },
+    { NULL, 0, 0, 0 }
+};
+
+class BtrfsDeviceAdd {
+public:
+    INT_PTR CALLBACK DeviceAddDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
+    void ShowDialog();
+    void AddDevice(HWND hwndDlg);
+    BtrfsDeviceAdd(HINSTANCE hinst, HWND hwnd, WCHAR* cmdline);
+
+private:
+    void populate_device_tree(HWND tree);
+
+    HINSTANCE hinst;
+    HWND hwnd;
+    WCHAR* cmdline;
+    device* sel;
+    std::vector<device> device_list;
+};
+
+class BtrfsDeviceResize {
+public:
+    INT_PTR CALLBACK DeviceResizeDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
+    void ShowDialog(HWND hwnd, WCHAR* fn, UINT64 dev_id);
+
+private:
+    void do_resize(HWND hwndDlg);
+
+    UINT64 dev_id, new_size;
+    WCHAR fn[MAX_PATH], new_size_text[255];
+    btrfs_device dev_info;
+};

Modification de propriétés sur dll/shellext/shellbtrfs/devices.h
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Index: dll/shellext/shellbtrfs/factory.cpp
===================================================================
--- dll/shellext/shellbtrfs/factory.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/factory.cpp	(copie de travail)
@@ -1,27 +1,29 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
+#include "shellext.h"
 #include <windows.h>
 #include "factory.h"
 #include "iconoverlay.h"
 #include "contextmenu.h"
 #include "propsheet.h"
+#include "volpropsheet.h"
 
-HRESULT __stdcall Factory::QueryInterface(const IID& iid, void** ppv) {    
+HRESULT __stdcall Factory::QueryInterface(const IID& iid, void** ppv) {
     if (iid == IID_IUnknown || iid == IID_IClassFactory) {
         *ppv = static_cast<IClassFactory*>(this);
     } else {
@@ -52,31 +54,41 @@
                 return bio->QueryInterface(iid, ppv);
             }
             break;
-            
+
         case FactoryContextMenu:
             if (iid == IID_IUnknown || iid == IID_IContextMenu || iid == IID_IShellExtInit) {
                 BtrfsContextMenu* bcm = new BtrfsContextMenu;
                 if (!bcm)
                     return E_OUTOFMEMORY;
-                
+
                 return bcm->QueryInterface(iid, ppv);
             }
             break;
-            
+
         case FactoryPropSheet:
             if (iid == IID_IUnknown || iid == IID_IShellPropSheetExt || iid == IID_IShellExtInit) {
                 BtrfsPropSheet* bps = new BtrfsPropSheet;
                 if (!bps)
                     return E_OUTOFMEMORY;
-                
+
                 return bps->QueryInterface(iid, ppv);
             }
             break;
-            
+
+        case FactoryVolPropSheet:
+            if (iid == IID_IUnknown || iid == IID_IShellPropSheetExt || iid == IID_IShellExtInit) {
+                BtrfsVolPropSheet* bps = new BtrfsVolPropSheet;
+                if (!bps)
+                    return E_OUTOFMEMORY;
+
+                return bps->QueryInterface(iid, ppv);
+            }
+            break;
+
         default:
             break;
     }
-    
+
     *ppv = NULL;
     return E_NOINTERFACE;
 }
Index: dll/shellext/shellbtrfs/factory.h
===================================================================
--- dll/shellext/shellbtrfs/factory.h	(révision 75772)
+++ dll/shellext/shellbtrfs/factory.h	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -21,7 +21,8 @@
     FactoryUnknown,
     FactoryIconHandler,
     FactoryContextMenu,
-    FactoryPropSheet
+    FactoryPropSheet,
+    FactoryVolPropSheet
 } factory_type;
 
 class Factory : public IClassFactory {
@@ -37,9 +38,9 @@
     }
 
     // IUnknown
-    
+
     HRESULT __stdcall QueryInterface(REFIID riid, void **ppObj);
-    
+
     ULONG __stdcall AddRef() {
         return InterlockedIncrement(&refcount);
     }
@@ -46,18 +47,18 @@
 
     ULONG __stdcall Release() {
         LONG rc = InterlockedDecrement(&refcount);
-        
+
         if (rc == 0)
             delete this;
-        
+
         return rc;
     }
 
     // IClassFactory
-    
+
     virtual HRESULT __stdcall CreateInstance(IUnknown* pUnknownOuter, const IID& iid, void** ppv);
     virtual HRESULT __stdcall LockServer(BOOL bLock);
-    
+
     factory_type type;
 
 private:
Index: dll/shellext/shellbtrfs/iconoverlay.cpp
===================================================================
--- dll/shellext/shellbtrfs/iconoverlay.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/iconoverlay.cpp	(copie de travail)
@@ -1,20 +1,21 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
+#include "shellext.h"
 #ifndef __REACTOS__
 #include <windows.h>
 #include <winternl.h>
@@ -28,25 +29,12 @@
 #ifndef __REACTOS__
 #include "../btrfsioctl.h"
 #else
-#include "../../drivers/filesystems/btrfs/btrfsioctl.h"
+#include "btrfsioctl.h"
 #endif
 
-#ifndef __REACTOS__
-#ifdef __cplusplus
-extern "C" {
-#endif
-NTSYSCALLAPI NTSTATUS NTAPI NtFsControlFile(HANDLE FileHandle, HANDLE Event, PIO_APC_ROUTINE ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, ULONG FsControlCode, PVOID InputBuffer, ULONG InputBufferLength, PVOID OutputBuffer, ULONG OutputBufferLength);
-#ifdef __cplusplus
-}
-#endif
-#define STATUS_SUCCESS 0
-#endif
-
-extern HMODULE module;
-
 HRESULT __stdcall BtrfsIconOverlay::QueryInterface(REFIID riid, void **ppObj) {
     if (riid == IID_IUnknown || riid == IID_IShellIconOverlayIdentifier) {
-        *ppObj = static_cast<IShellIconOverlayIdentifier*>(this); 
+        *ppObj = static_cast<IShellIconOverlayIdentifier*>(this);
         AddRef();
         return S_OK;
     }
@@ -57,22 +45,22 @@
 
 HRESULT __stdcall BtrfsIconOverlay::GetOverlayInfo(PWSTR pwszIconFile, int cchMax, int* pIndex, DWORD* pdwFlags) {
     WCHAR dllpath[MAX_PATH];
-    
+
     GetModuleFileNameW(module, dllpath, sizeof(dllpath));
-    
-    if (cchMax < (int)wcslen(dllpath))
+
+    if ((size_t)cchMax < wcslen(dllpath))
         return E_INVALIDARG;
-    
+
     if (!pIndex)
         return E_INVALIDARG;
-    
+
     if (!pdwFlags)
         return E_INVALIDARG;
-    
+
     wcscpy(pwszIconFile, dllpath);
     *pIndex = 0;
     *pdwFlags = ISIOI_ICONFILE | ISIOI_ICONINDEX;
-    
+
     return S_OK;
 }
 
@@ -79,9 +67,9 @@
 HRESULT __stdcall BtrfsIconOverlay::GetPriority(int *pPriority) {
     if (!pPriority)
         return E_INVALIDARG;
-    
+
     *pPriority = 0;
-    
+
     return S_OK;
 }
 
@@ -90,20 +78,20 @@
     NTSTATUS Status;
     IO_STATUS_BLOCK iosb;
     btrfs_get_file_ids bgfi;
-    
+
     h = CreateFileW(pwszPath, 0, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OPEN_REPARSE_POINT, NULL);
-    
+
     if (h == INVALID_HANDLE_VALUE)
         return S_FALSE;
-    
+
     Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_FILE_IDS, NULL, 0, &bgfi, sizeof(btrfs_get_file_ids));
-    
-    if (Status != STATUS_SUCCESS) {
+
+    if (!NT_SUCCESS(Status)) {
         CloseHandle(h);
         return S_FALSE;
     }
 
     CloseHandle(h);
-    
+
     return (bgfi.inode == 0x100 && !bgfi.top) ? S_OK : S_FALSE;
 }
Index: dll/shellext/shellbtrfs/iconoverlay.h
===================================================================
--- dll/shellext/shellbtrfs/iconoverlay.h	(révision 75772)
+++ dll/shellext/shellbtrfs/iconoverlay.h	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -31,9 +31,9 @@
     }
 
     // IUnknown
-    
+
     HRESULT __stdcall QueryInterface(REFIID riid, void **ppObj);
-    
+
     ULONG __stdcall AddRef() {
         return InterlockedIncrement(&refcount);
     }
@@ -40,15 +40,15 @@
 
     ULONG __stdcall Release() {
         LONG rc = InterlockedDecrement(&refcount);
-        
+
         if (rc == 0)
             delete this;
-        
+
         return rc;
     }
 
     // IShellIconOverlayIdentifier
-    
+
     virtual HRESULT __stdcall GetOverlayInfo(PWSTR pwszIconFile, int cchMax, int* pIndex, DWORD* pdwFlags);
     virtual HRESULT __stdcall GetPriority(int *pPriority);
     virtual HRESULT __stdcall IsMemberOf(PCWSTR pwszPath, DWORD dwAttrib);
